Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Botan::CAST_256 Class Referencefinal

`#include <cast256.h>`

Inheritance diagram for Botan::CAST_256:

## Public Types
enum |

## Public Member Functions
size_t | block_size () const override
void | clear () override
BlockCipher * | clone () const override
void | decrypt (const uint8_t in[], uint8_t out[]) const
void | decrypt (uint8_t block[]) const
template<typename Alloc >
void | decrypt (std::vector< uint8_t, Alloc > &block) const
template<typename Alloc , typename Alloc2 >
void | decrypt (const std::vector< uint8_t, Alloc > &in, std::vector< uint8_t, Alloc2 > &out) const
void | decrypt_n (const uint8_t in[], uint8_t out[], size_t blocks) const override
void | encrypt (const uint8_t in[], uint8_t out[]) const
void | encrypt (uint8_t block[]) const
template<typename Alloc >
void | encrypt (std::vector< uint8_t, Alloc > &block) const
template<typename Alloc , typename Alloc2 >
void | encrypt (const std::vector< uint8_t, Alloc > &in, std::vector< uint8_t, Alloc2 > &out) const
void | encrypt_n (const uint8_t in[], uint8_t out[], size_t blocks) const override
Key_Length_Specification | key_spec () const override
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const override
size_t | parallel_bytes () const
virtual size_t | parallelism () const
virtual std::string | provider () const
void | set_key (const SymmetricKey &key)
template<typename Alloc >
void | set_key (const std::vector< uint8_t, Alloc > &key)
void | set_key (const uint8_t key[], size_t length)
bool | valid_keylength (size_t length) const

## Static Public Member Functions
static std::unique_ptr< BlockCipher > | create (const std::string &algo_spec, const std::string &provider="")
static std::unique_ptr< BlockCipher > | create_or_throw (const std::string &algo_spec, const std::string &provider="")
static std::vector< std::string > | providers (const std::string &algo_spec)

## Detailed Description

CAST-256

Definition at line 18 of file cast256.h.

## Member Enumeration Documentation

anonymous enum
| inherited

Definition at line 186 of file block_cipher.h.

186 { BLOCK_SIZE = BS };
Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE
Definition: block_cipher.h:186

## Member Function Documentation

size_t Botan::Block_Cipher_Fixed_Params< BS, KMIN, KMAX, KMOD >::block_size | ( |  | ) | const
| inline override virtual inherited

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 187 of file block_cipher.h.

187 { return BS; }

void Botan::CAST_256::clear | ( |  | ) |
| override virtual

Reset the state.

Implements Botan::SymmetricAlgorithm.

Definition at line 221 of file cast256.cpp.

References Botan::zap().

222 {
223 zap(m_MK);
224 zap(m_RK);
225 }
Botan::zap
void zap(std::vector< T, Alloc > &vec)
Definition: secmem.h:221

BlockCipher* Botan::CAST_256::clone | ( |  | ) | const
| inline override virtual

Returns
  new object representing the same algorithm as *this

Implements Botan::BlockCipher.

Definition at line 26 of file cast256.h.

26 { return new CAST_256; }

std::unique_ptr< BlockCipher > Botan::BlockCipher::create | ( | const std::string & | algo_spec,
|  | const std::string & | provider = `""`
| ) |  |
| static inherited

Create an instance based on a name If provider is empty then best available is chosen.

Parameters

  algo_spec | algorithm name
  provider | provider implementation to choose

Returns
  a null pointer if the algo/provider combination cannot be found

Definition at line 88 of file block_cipher.cpp.

References Botan::SCAN_Name::algo_name(), Botan::SCAN_Name::arg(), Botan::SCAN_Name::arg_as_integer(), Botan::SCAN_Name::arg_count(), Botan::SCAN_Name::arg_count_between(), Botan::BlockCipher::block_size(), BOTAN_UNUSED, Botan::HashFunction::create(), Botan::StreamCipher::create(), hash, and Botan::make_openssl_block_cipher().

Referenced by botan_block_cipher_init(), Botan::MessageAuthenticationCode::create(), Botan::StreamCipher::create(), Botan::BlockCipher::create_or_throw(), Botan::get_aead(), Botan::get_block_cipher(), and Botan::get_cipher_mode().

90 {
91 #if defined(BOTAN_HAS_OPENSSL)
92 if(provider.empty() || provider == "openssl")
93 {
94 if(auto bc = make_openssl_block_cipher(algo))
95 return bc;
96
97 if(!provider.empty())
98 return nullptr;
99 }
100 #endif
101
102 // TODO: CommonCrypto
103 // TODO: CryptoAPI
104 // TODO: /dev/crypto
105
106 // Only base providers from here on out
107 if(provider.empty() == false && provider != "base")
108 return nullptr;
109
110 #if defined(BOTAN_HAS_AES)
111 if(algo == "AES-128")
112 {
113 return std::unique_ptr<BlockCipher>(new AES_128);
114 }
115
116 if(algo == "AES-192")
117 {
118 return std::unique_ptr<BlockCipher>(new AES_192);
119 }
120
121 if(algo == "AES-256")
122 {
123 return std::unique_ptr<BlockCipher>(new AES_256);
124 }
125 #endif
126
127 #if defined(BOTAN_HAS_SERPENT)
128 if(algo == "Serpent")
129 {
130 return std::unique_ptr<BlockCipher>(new Serpent);
131 }
132 #endif
133
134 #if defined(BOTAN_HAS_TWOFISH)
135 if(algo == "Twofish")
136 {
137 return std::unique_ptr<BlockCipher>(new Twofish);
138 }
139 #endif
140
141 #if defined(BOTAN_HAS_THREEFISH_512)
142 if(algo == "Threefish-512")
143 {
144 return std::unique_ptr<BlockCipher>(new Threefish_512);
145 }
146 #endif
147
148 #if defined(BOTAN_HAS_BLOWFISH)
149 if(algo == "Blowfish")
150 {
151 return std::unique_ptr<BlockCipher>(new Blowfish);
152 }
153 #endif
154
155 #if defined(BOTAN_HAS_CAMELLIA)
156 if(algo == "Camellia-128")
157 {
158 return std::unique_ptr<BlockCipher>(new Camellia_128);
159 }
160
161 if(algo == "Camellia-192")
162 {
163 return std::unique_ptr<BlockCipher>(new Camellia_192);
164 }
165
166 if(algo == "Camellia-256")
167 {
168 return std::unique_ptr<BlockCipher>(new Camellia_256);
169 }
170 #endif
171
172 #if defined(BOTAN_HAS_DES)
173 if(algo == "DES")
174 {
175 return std::unique_ptr<BlockCipher>(new DES);
176 }
177
178 if(algo == "DESX")
179 {
180 return std::unique_ptr<BlockCipher>(new DESX);
181 }
182
183 if(algo == "TripleDES" || algo == "3DES" || algo == "DES-EDE")
184 {
185 return std::unique_ptr<BlockCipher>(new TripleDES);
186 }
187 #endif
188
189 #if defined(BOTAN_HAS_NOEKEON)
190 if(algo == "Noekeon")
191 {
192 return std::unique_ptr<BlockCipher>(new Noekeon);
193 }
194 #endif
195
196 #if defined(BOTAN_HAS_CAST)
197 if(algo == "CAST-128" || algo == "CAST5")
198 {
199 return std::unique_ptr<BlockCipher>(new CAST_128);
200 }
201
202 if(algo == "CAST-256")
203 {
204 return std::unique_ptr<BlockCipher>(new CAST_256);
205 }
206 #endif
207
208 #if defined(BOTAN_HAS_IDEA)
209 if(algo == "IDEA")
210 {
211 return std::unique_ptr<BlockCipher>(new IDEA);
212 }
213 #endif
214
215 #if defined(BOTAN_HAS_KASUMI)
216 if(algo == "KASUMI")
217 {
218 return std::unique_ptr<BlockCipher>(new KASUMI);
219 }
220 #endif
221
222 #if defined(BOTAN_HAS_MISTY1)
223 if(algo == "MISTY1")
224 {
225 return std::unique_ptr<BlockCipher>(new MISTY1);
226 }
227 #endif
228
229 #if defined(BOTAN_HAS_SEED)
230 if(algo == "SEED")
231 {
232 return std::unique_ptr<BlockCipher>(new SEED);
233 }
234 #endif
235
236 #if defined(BOTAN_HAS_XTEA)
237 if(algo == "XTEA")
238 {
239 return std::unique_ptr<BlockCipher>(new XTEA);
240 }
241 #endif
242
243 const SCAN_Name req(algo);
244
245 #if defined(BOTAN_HAS_GOST_28147_89)
246 if(req.algo_name() == "GOST-28147-89")
247 {
248 return std::unique_ptr<BlockCipher>(new GOST_28147_89(req.arg(0, "R3411_94_TestParam")));
249 }
250 #endif
251
252 #if defined(BOTAN_HAS_CASCADE)
253 if(req.algo_name() == "Cascade" && req.arg_count() == 2)
254 {
255 std::unique_ptr<BlockCipher> c1(BlockCipher::create(req.arg(0)));
256 std::unique_ptr<BlockCipher> c2(BlockCipher::create(req.arg(1)));
257
258 if(c1 && c2)
259 return std::unique_ptr<BlockCipher>(new Cascade_Cipher(c1.release(), c2.release()));
260 }
261 #endif
262
263 #if defined(BOTAN_HAS_LION)
264 if(req.algo_name() == "Lion" && req.arg_count_between(2, 3))
265 {
266 std::unique_ptr<HashFunction> hash(HashFunction::create(req.arg(0)));
267 std::unique_ptr<StreamCipher> stream(StreamCipher::create(req.arg(1)));
268
269 if(hash && stream)
270 {
271 const size_t block_size = req.arg_as_integer(2, 1024);
272 return std::unique_ptr<BlockCipher>(new Lion(hash.release(), stream.release(), block_size));
273 }
274 }
275 #endif
276
277 BOTAN_UNUSED(req);
278 BOTAN_UNUSED(provider);
279
280 return nullptr;
281 }
Botan::PKCS11::KeyType::Twofish
BOTAN_UNUSED
#define BOTAN_UNUSED(v)
Definition: assert.h:92
Botan::HashFunction::create
static std::unique_ptr< HashFunction > create(const std::string &algo_spec, const std::string &provider="")
Definition: hash.cpp:93
Botan::BlockCipher::create
static std::unique_ptr< BlockCipher > create(const std::string &algo_spec, const std::string &provider="")
Definition: block_cipher.cpp:88
Botan::PKCS11::KeyType::Blowfish
Botan::StreamCipher::create
static std::unique_ptr< StreamCipher > create(const std::string &algo_spec, const std::string &provider="")
Definition: stream_cipher.cpp:41
Botan::BlockCipher::provider
virtual std::string provider() const
Definition: block_cipher.h:71
Botan::make_openssl_block_cipher
std::unique_ptr< BlockCipher > make_openssl_block_cipher(const std::string &name)
Definition: openssl_block.cpp:157
Botan::BlockCipher::block_size
virtual size_t block_size() const =0
hash
MechanismType hash
Definition: p11_mechanism.cpp:63

std::unique_ptr< BlockCipher > Botan::BlockCipher::create_or_throw | ( | const std::string & | algo_spec,
|  | const std::string & | provider = `""`
| ) |  |
| static inherited

Create an instance based on a name, or throw if the algo/provider combination cannot be found. If provider is empty then best available is chosen.

Definition at line 285 of file block_cipher.cpp.

References Botan::BlockCipher::create().

Referenced by Botan::make_block_cipher(), Botan::rfc3394_keyunwrap(), Botan::rfc3394_keywrap(), and Botan::TLS::TLS_CBC_HMAC_AEAD_Mode::TLS_CBC_HMAC_AEAD_Mode().

287 {
288 if(auto bc = BlockCipher::create(algo, provider))
289 {
290 return bc;
291 }
292 throw Lookup_Error("Block cipher", algo, provider);
293 }
Botan::BlockCipher::create
static std::unique_ptr< BlockCipher > create(const std::string &algo_spec, const std::string &provider="")
Definition: block_cipher.cpp:88
Botan::BlockCipher::provider
virtual std::string provider() const
Definition: block_cipher.h:71

void Botan::BlockCipher::decrypt | ( | const uint8_t | in[],
|  | uint8_t | out[]
| ) |  | const
| inline inherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 90 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n(), Botan::XTS_Decryption::finish(), and Botan::CTS_Decryption::finish().

91 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const =0

void Botan::BlockCipher::decrypt | ( | uint8_t | block[] | ) | const
| inline inherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 107 of file block_cipher.h.

107 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const =0
template<typename Alloc >

void Botan::BlockCipher::decrypt | ( | std::vector< uint8_t, Alloc > & | block | ) | const
| inline inherited

Decrypt one or more blocks

Parameters

  block | the input/output buffer (multiple of block_size())

Definition at line 124 of file block_cipher.h.

125 {
126 return decrypt_n(block.data(), block.data(), block.size() / block_size());
127 }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const =0
Botan::BlockCipher::block_size
virtual size_t block_size() const =0
template<typename Alloc , typename Alloc2 >

void Botan::BlockCipher::decrypt | ( | const std::vector< uint8_t, Alloc > & | in,
|  | std::vector< uint8_t, Alloc2 > & | out
| ) |  | const
| inline inherited

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)

Definition at line 147 of file block_cipher.h.

149 {
150 return decrypt_n(in.data(), out.data(), in.size() / block_size());
151 }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const =0
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

void Botan::CAST_256::decrypt_n | ( | const uint8_t | in[],
|  | uint8_t | out[],
|  | size_t | blocks
| ) |  | const
| override virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 95 of file cast256.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE, Botan::load_be< uint32_t >(), and Botan::store_be().

96 {
97 for(size_t i = 0; i != blocks; ++i)
98 {
99 uint32_t A = load_be<uint32_t>(in, 0);
100 uint32_t B = load_be<uint32_t>(in, 1);
101 uint32_t C = load_be<uint32_t>(in, 2);
102 uint32_t D = load_be<uint32_t>(in, 3);
103
104 round1(C, D, m_MK[44], m_RK[44]); round2(B, C, m_MK[45], m_RK[45]);
105 round3(A, B, m_MK[46], m_RK[46]); round1(D, A, m_MK[47], m_RK[47]);
106 round1(C, D, m_MK[40], m_RK[40]); round2(B, C, m_MK[41], m_RK[41]);
107 round3(A, B, m_MK[42], m_RK[42]); round1(D, A, m_MK[43], m_RK[43]);
108 round1(C, D, m_MK[36], m_RK[36]); round2(B, C, m_MK[37], m_RK[37]);
109 round3(A, B, m_MK[38], m_RK[38]); round1(D, A, m_MK[39], m_RK[39]);
110 round1(C, D, m_MK[32], m_RK[32]); round2(B, C, m_MK[33], m_RK[33]);
111 round3(A, B, m_MK[34], m_RK[34]); round1(D, A, m_MK[35], m_RK[35]);
112 round1(C, D, m_MK[28], m_RK[28]); round2(B, C, m_MK[29], m_RK[29]);
113 round3(A, B, m_MK[30], m_RK[30]); round1(D, A, m_MK[31], m_RK[31]);
114 round1(C, D, m_MK[24], m_RK[24]); round2(B, C, m_MK[25], m_RK[25]);
115 round3(A, B, m_MK[26], m_RK[26]); round1(D, A, m_MK[27], m_RK[27]);
116 round1(D, A, m_MK[23], m_RK[23]); round3(A, B, m_MK[22], m_RK[22]);
117 round2(B, C, m_MK[21], m_RK[21]); round1(C, D, m_MK[20], m_RK[20]);
118 round1(D, A, m_MK[19], m_RK[19]); round3(A, B, m_MK[18], m_RK[18]);
119 round2(B, C, m_MK[17], m_RK[17]); round1(C, D, m_MK[16], m_RK[16]);
120 round1(D, A, m_MK[15], m_RK[15]); round3(A, B, m_MK[14], m_RK[14]);
121 round2(B, C, m_MK[13], m_RK[13]); round1(C, D, m_MK[12], m_RK[12]);
122 round1(D, A, m_MK[11], m_RK[11]); round3(A, B, m_MK[10], m_RK[10]);
123 round2(B, C, m_MK[ 9], m_RK[ 9]); round1(C, D, m_MK[ 8], m_RK[ 8]);
124 round1(D, A, m_MK[ 7], m_RK[ 7]); round3(A, B, m_MK[ 6], m_RK[ 6]);
125 round2(B, C, m_MK[ 5], m_RK[ 5]); round1(C, D, m_MK[ 4], m_RK[ 4]);
126 round1(D, A, m_MK[ 3], m_RK[ 3]); round3(A, B, m_MK[ 2], m_RK[ 2]);
127 round2(B, C, m_MK[ 1], m_RK[ 1]); round1(C, D, m_MK[ 0], m_RK[ 0]);
128
129 store_be(out, A, B, C, D);
130
131 in += BLOCK_SIZE;
132 out += BLOCK_SIZE;
133 }
134 }
Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE
Definition: block_cipher.h:186
Botan::store_be
void store_be(uint16_t in, uint8_t out[2])
Definition: loadstor.h:441
Botan::load_be< uint32_t >
uint32_t load_be< uint32_t >(const uint8_t in[], size_t off)
Definition: loadstor.h:185

void Botan::BlockCipher::encrypt | ( | const uint8_t | in[],
|  | uint8_t | out[]
| ) |  | const
| inline inherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 80 of file block_cipher.h.

Referenced by Botan::aont_package(), Botan::aont_unpackage(), Botan::DESX::encrypt_n(), Botan::XTS_Encryption::finish(), Botan::CTS_Encryption::finish(), Botan::CFB_Encryption::process(), Botan::CBC_Encryption::process(), and Botan::CFB_Decryption::process().

81 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const =0

void Botan::BlockCipher::encrypt | ( | uint8_t | block[] | ) | const
| inline inherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 99 of file block_cipher.h.

99 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const =0
template<typename Alloc >

void Botan::BlockCipher::encrypt | ( | std::vector< uint8_t, Alloc > & | block | ) | const
| inline inherited

Encrypt one or more blocks

Parameters

  block | the input/output buffer (multiple of block_size())

Definition at line 114 of file block_cipher.h.

115 {
116 return encrypt_n(block.data(), block.data(), block.size() / block_size());
117 }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const =0
Botan::BlockCipher::block_size
virtual size_t block_size() const =0
template<typename Alloc , typename Alloc2 >

void Botan::BlockCipher::encrypt | ( | const std::vector< uint8_t, Alloc > & | in,
|  | std::vector< uint8_t, Alloc2 > & | out
| ) |  | const
| inline inherited

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)

Definition at line 135 of file block_cipher.h.

137 {
138 return encrypt_n(in.data(), out.data(), in.size() / block_size());
139 }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const =0
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

void Botan::CAST_256::encrypt_n | ( | const uint8_t | in[],
|  | uint8_t | out[],
|  | size_t | blocks
| ) |  | const
| override virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 51 of file cast256.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE, Botan::load_be< uint32_t >(), and Botan::store_be().

52 {
53 for(size_t i = 0; i != blocks; ++i)
54 {
55 uint32_t A = load_be<uint32_t>(in, 0);
56 uint32_t B = load_be<uint32_t>(in, 1);
57 uint32_t C = load_be<uint32_t>(in, 2);
58 uint32_t D = load_be<uint32_t>(in, 3);
59
60 round1(C, D, m_MK[ 0], m_RK[ 0]); round2(B, C, m_MK[ 1], m_RK[ 1]);
61 round3(A, B, m_MK[ 2], m_RK[ 2]); round1(D, A, m_MK[ 3], m_RK[ 3]);
62 round1(C, D, m_MK[ 4], m_RK[ 4]); round2(B, C, m_MK[ 5], m_RK[ 5]);
63 round3(A, B, m_MK[ 6], m_RK[ 6]); round1(D, A, m_MK[ 7], m_RK[ 7]);
64 round1(C, D, m_MK[ 8], m_RK[ 8]); round2(B, C, m_MK[ 9], m_RK[ 9]);
65 round3(A, B, m_MK[10], m_RK[10]); round1(D, A, m_MK[11], m_RK[11]);
66 round1(C, D, m_MK[12], m_RK[12]); round2(B, C, m_MK[13], m_RK[13]);
67 round3(A, B, m_MK[14], m_RK[14]); round1(D, A, m_MK[15], m_RK[15]);
68 round1(C, D, m_MK[16], m_RK[16]); round2(B, C, m_MK[17], m_RK[17]);
69 round3(A, B, m_MK[18], m_RK[18]); round1(D, A, m_MK[19], m_RK[19]);
70 round1(C, D, m_MK[20], m_RK[20]); round2(B, C, m_MK[21], m_RK[21]);
71 round3(A, B, m_MK[22], m_RK[22]); round1(D, A, m_MK[23], m_RK[23]);
72 round1(D, A, m_MK[27], m_RK[27]); round3(A, B, m_MK[26], m_RK[26]);
73 round2(B, C, m_MK[25], m_RK[25]); round1(C, D, m_MK[24], m_RK[24]);
74 round1(D, A, m_MK[31], m_RK[31]); round3(A, B, m_MK[30], m_RK[30]);
75 round2(B, C, m_MK[29], m_RK[29]); round1(C, D, m_MK[28], m_RK[28]);
76 round1(D, A, m_MK[35], m_RK[35]); round3(A, B, m_MK[34], m_RK[34]);
77 round2(B, C, m_MK[33], m_RK[33]); round1(C, D, m_MK[32], m_RK[32]);
78 round1(D, A, m_MK[39], m_RK[39]); round3(A, B, m_MK[38], m_RK[38]);
79 round2(B, C, m_MK[37], m_RK[37]); round1(C, D, m_MK[36], m_RK[36]);
80 round1(D, A, m_MK[43], m_RK[43]); round3(A, B, m_MK[42], m_RK[42]);
81 round2(B, C, m_MK[41], m_RK[41]); round1(C, D, m_MK[40], m_RK[40]);
82 round1(D, A, m_MK[47], m_RK[47]); round3(A, B, m_MK[46], m_RK[46]);
83 round2(B, C, m_MK[45], m_RK[45]); round1(C, D, m_MK[44], m_RK[44]);
84
85 store_be(out, A, B, C, D);
86
87 in += BLOCK_SIZE;
88 out += BLOCK_SIZE;
89 }
90 }
Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE
Definition: block_cipher.h:186
Botan::store_be
void store_be(uint16_t in, uint8_t out[2])
Definition: loadstor.h:441
Botan::load_be< uint32_t >
uint32_t load_be< uint32_t >(const uint8_t in[], size_t off)
Definition: loadstor.h:185

Key_Length_Specification Botan::Block_Cipher_Fixed_Params< BS, KMIN, KMAX, KMOD >::key_spec | ( |  | ) | const
| inline override virtual inherited

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 189 of file block_cipher.h.

190 {
191 return Key_Length_Specification(KMIN, KMAX, KMOD);
192 }

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inline inherited

Returns
  minimum allowed key length

Definition at line 39 of file sym_algo.h.

40 {
41 return key_spec().maximum_keylength();
42 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inline inherited

Returns
  maximum allowed key length

Definition at line 47 of file sym_algo.h.

48 {
49 return key_spec().minimum_keylength();
50 }
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

std::string Botan::CAST_256::name | ( |  | ) | const
| inline override virtual

Returns
  the algorithm name

Implements Botan::SymmetricAlgorithm.

Definition at line 25 of file cast256.h.

25 { return "CAST-256"; }

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inline inherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 62 of file block_cipher.h.

Referenced by Botan::XTS_Mode::update_granularity(), and Botan::CBC_Mode::update_granularity().

63 {
64 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
65 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:57
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

virtual size_t Botan::BlockCipher::parallelism | ( |  | ) | const
| inline virtual inherited

Returns
  native parallelism of this cipher in blocks

Reimplemented in Botan::Serpent.

Definition at line 57 of file block_cipher.h.

57 { return 1; }

virtual std::string Botan::BlockCipher::provider | ( |  | ) | const
| inline virtual inherited

Returns
  provider information about this implementation. Default is "base", might also return "sse2", "avx2", "openssl", or some other arbitrary string.

Reimplemented in Botan::AES_256, Botan::AES_192, Botan::Threefish_512, Botan::AES_128, Botan::IDEA, Botan::Serpent, and Botan::Noekeon.

Definition at line 71 of file block_cipher.h.

71 { return "base"; }

std::vector< std::string > Botan::BlockCipher::providers | ( | const std::string & | algo_spec | ) |
| static inherited

Returns
  list of available providers for this algorithm, empty if not available

Parameters

  algo_spec | algorithm name

Definition at line 295 of file block_cipher.cpp.

Referenced by Botan::get_block_cipher_providers().

296 {
297 return probe_providers_of<BlockCipher>(algo, { "base", "openssl" });
298 }

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 66 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_package(), Botan::aont_unpackage(), botan_block_cipher_set_key(), botan_mac_set_key(), and Botan::pbkdf2().

67 {
68 set_key(key.begin(), key.length());
69 }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:66
template<typename Alloc >

void Botan::SymmetricAlgorithm::set_key | ( | const std::vector< uint8_t, Alloc > & | key | ) |
| inline inherited

Definition at line 72 of file sym_algo.h.

73 {
74 set_key(key.data(), key.size());
75 }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:66

void Botan::SymmetricAlgorithm::set_key | ( | const uint8_t | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 82 of file sym_algo.h.

83 {
84 if(!valid_keylength(length))
85 throw Invalid_Key_Length(name(), length);
86 key_schedule(key, length);
87 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:57
Botan::SymmetricAlgorithm::name
virtual std::string name() const =0

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 57 of file sym_algo.h.

Referenced by Botan::aont_package(), and Botan::aont_unpackage().

58 {
59 return key_spec().valid_keylength(length);
60 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/lib/block/cast/cast256.h
- src/lib/block/cast/cast256.cpp